﻿Public Class WebForm1
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If IsPostBack Then
            Return
        End If

        FpSpread1.Sheets(0).RowCount = 3
        FpSpread1.Sheets(0).ColumnCount = 3
        FpSpread1.Sheets(0).SetClip(0, 0, 1, 3, "James" & vbTab & "England" & vbTab & "10")
        FpSpread1.Sheets(0).SetClip(1, 0, 1, 3, "Peter" & vbTab & "England" & vbTab & "20")
        FpSpread1.Sheets(0).SetClip(2, 0, 1, 3, "Scott" & vbTab & "USA" & vbTab & "5")


        FpSpread1.Sheets(0).Columns(0).Label = "Name"
        FpSpread1.Sheets(0).Columns(1).Label = "Country"
        FpSpread1.Sheets(0).Columns(2).Label = "Number"
        FpSpread1.EnableAjaxCall = False
        FpSpread1.ActiveSheetView.AllowGroup = True
        FpSpread1.ActiveSheetView.AllowColumnMove = True
        FpSpread1.ActiveSheetView.GroupBarVisible = True
    End Sub
    'This code works when grouping is done either by the end user dynamically i.e. 
    'dragging columns to group bar or when the grouping is done through code behind 
    'as on a button click.
    Private Sub CalculateGroups(sender As Object)
        Dim ss As FarPoint.Web.Spread.FpSpread = DirectCast(sender, FarPoint.Web.Spread.FpSpread)
        Dim gm As FarPoint.Web.Spread.Model.GroupDataModel
        Dim total As Integer
        Dim column As Integer = 0
        Dim y As Integer = 0
        gm = DirectCast(ss.ActiveSheetView.DataModel, FarPoint.Web.Spread.Model.GroupDataModel)

        For i As Integer = 0 To ss.ActiveSheetView.NonEmptyRowCount - 1
            If gm.IsGroup(i) Then
                Dim g As FarPoint.Web.Spread.Model.Group
                g = gm.GetGroup(i)
                g.Expanded = False
                total = 0

                total = g.Rows.Count
                column = g.Column

                Dim s As String = gm.TargetModel.GetValue(getRow(g), column).ToString()
                s = Convert.ToString(column.ToString() + ":") & s
                g.Text = (s & Convert.ToString(" (")) + total.ToString() + ")"
            End If
        Next
    End Sub

    Private Function getRow(group As FarPoint.Web.Spread.Model.Group) As Integer
        If TypeOf group.Rows(0) Is FarPoint.Web.Spread.Model.Group Then
            Return getRow(TryCast(group.Rows(0), FarPoint.Web.Spread.Model.Group))
        End If
        Return CInt(group.Rows(0))
    End Function

    Protected Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim gm As New FarPoint.Web.Spread.Model.GroupDataModel(FpSpread1.ActiveSheetView.DataModel)
        Dim sort1 As FarPoint.Web.Spread.SortInfo() = New FarPoint.Web.Spread.SortInfo(2) {}
        sort1(0) = New FarPoint.Web.Spread.SortInfo(0, True)
        sort1(1) = New FarPoint.Web.Spread.SortInfo(1, True)
        sort1(2) = New FarPoint.Web.Spread.SortInfo(2, True)
        gm.Group(sort1)

        FpSpread1.ActiveSheetView.DataModel = gm
        CalculateGroups(FpSpread1)
    End Sub

    Protected Sub FpSpread1_Grouped(sender As Object, e As EventArgs) Handles FpSpread1.Grouped
        Dim ss As FarPoint.Web.Spread.FpSpread = DirectCast(sender, FarPoint.Web.Spread.FpSpread)
        If ss.ActiveSheetView.DataModel.[GetType]() = GetType(FarPoint.Web.Spread.Model.GroupDataModel) Then
            CalculateGroups(sender)
        End If
    End Sub
End Class